<?php
namespace Deployer;

require 'recipe/composer.php';

// Setup

import(__DIR__. '/inventory.yml');

// Hooks

after('deploy:failed', 'deploy:unlock');
after('deploy:vendors', 'deploy:d3OxidTasks');

/// Tasks

desc('Oxid related tasks');
task('deploy:d3OxidTasks', [
    'deploy:clear_paths',
    'deploy:setShopsOffline',
    'deploy:setShopsOnline'
]);

desc('set shops offline');
task('deploy:setShopsOffline', function() {
    if (has('bin/mysql') && strlen(get('bin/mysql')) &&
        has('db_name') && strlen(get('db_name')) &&
        has('db_conf_path') && strlen(get('db_conf_path')) && test("[ -f {{db_conf_path}} ]")
    ) {
        $query = "UPDATE oxshops SET oxactive = '0', OXREGISTERSUBJECT = CONCAT('..', OXREGISTERSUBJECT) WHERE oxactive = '1';";
        run('{{bin/mysql}} --defaults-extra-file={{db_conf_path}} {{db_name}} -e "'.$query.'"');
    } else {
        info('missing config, task skipped');
    }
})->select('role=production,role=stage');

desc('set shops online');
task('deploy:setShopsOnline', function() {
    if (has('bin/mysql') && strlen(get('bin/mysql')) &&
        has('db_name') && strlen(get('db_name')) &&
        has('db_conf_path') && strlen(get('db_conf_path')) && test("[ -f {{db_conf_path}} ]")
    ) {
        $query = "UPDATE oxshops SET oxactive = '1', OXREGISTERSUBJECT = SUBSTR(OXREGISTERSUBJECT, 3) WHERE oxactive = '0' AND OXREGISTERSUBJECT LIKE '..%';";
        run('{{bin/mysql}} --defaults-extra-file={{db_conf_path}} {{db_name}} -e "'.$query.'"');
    } else {
        info('missing config, task skipped');
    }
})->select('role=production,role=stage');
